%************************************************************************
%      SUBROUTINE ADAM_RETRY(ERR0)
%************************************************************************

function [ERR0] = ADAM_RETRY(ERR0)
    global Y F ...
               H HOLD WT PHI ...
               PSI BETA ...
               ERK K ...
               KNEW IPHASE IFAIL
%
    IPHASE = 0;
    for I = 1 : K
        for L = 1 : 8
            PHI(L,I) = (PHI(L,I)-PHI(L,I+1))/BETA(I);
        end
    end

    for I = 2 : K
        PSI(I-1) = PSI(I) - H;
    end

      IFAIL = IFAIL+1;
%* Euler method
    if IFAIL >= 3
        KNEW = 1;
    end
    K = KNEW;

    if IFAIL > 3 && 0.5 * ERR0 < 0.25 * ERK
        H = sqrt(0.5 * ERR0 / ERK) * H;
    else
        H = 0.5 * H;
    end

%*** Derivative
    [Y, F] = FUNCT(Y,F,1);
end
