%************************************************************************
%      SUBROUTINE ADAM_UPDATE(ERR0)
%************************************************************************
%      IMPLICIT REAL*8(A-H,O-Z),INTEGER*4(I-N)
function [ERR0] = ADAM_UPDATE(ERR0)
    global Y P F ...
            H HOLD WT PHI PSIOLD ...
            PSI BETA SIGMA G ...
            ERKM1 ERK K KOLD ...
            KNEW KS IPHASE IFAIL ...

    GSTR = [0.500 0.0833 0.0417 0.0264 0.0188 ...
            0.0143 0.0114 0.00936 0.00789 0.00679 ...
            0.00592 0.00524 0.00468];

    TWO = [2.0 4.0 8.0 16.0 32.0 ...
            64.0 128.0 256.0 512.0 1024.0 ...
            2048.0 4096.0 8192.0];

%    for L = 1 : 8
%        Y(L) = P(L) + H * G(K+1) * (F(L)-PHI(L,1))
%    end
    Y(1 : 8) = P(1 : 8) + H * G(K + 1) * (F(1 : 8) - transpose(PHI(1 : 8, 1)));

    IFAIL = 0;
    KOLD  = K;
    HOLD  = H;

%*** Derivative
    [Y, F] = FUNCT(Y,F,1);

    for L = 1 : 8
        PHI(L,K+1) = F(L)-PHI(L,1);
        PHI(L,K+2) = PHI(L,K+1)-PHI(L,K+2);
    end

%
    for I = 1 : K
        for L = 1 : 8
            PHI(L,I) = PHI(L,I) + PHI(L,K+1);
        end
    end


    ERKP1 = 0.0;
    if KNEW == K - 1 || K == 12
        IPHASE = 0;
    end

    if IPHASE == 1
        K   = K + 1;
        ERK = ERKP1;
%         GOTO 500
%    end
    elseif KNEW == K - 1
        K   = K - 1;
        ERK = ERKM1;
%         GOTO 500
%    end
    elseif K + 1 <= KS
%        for L = 1 : 8
%            ERKP1 = ERKP1 + ( PHI(L, K + 2) / WT(L) )^2;
%        end
        ERKP1 = ERKP1 + sum(( PHI(1 : 8, K + 2).' ./ WT(1 : 8) ).^2, 2);
        ERKP1 = abs(H) * GSTR(K + 1) * sqrt(ERKP1);

        if K <= 1
            if ERKP1 < 0.5 * ERK
               K   = K + 1;
               ERK = ERKP1;
            end
%            GOTO 500
%        ENDIF
        elseif ERKM1 <= min([ERK ERKP1])
            K   = K - 1;
            ERK = ERKM1;
        elseif ERKP1 < ERK && K ~= 12
            K   = K + 1;
            ERK = ERKP1;
        end
    end

%500  CONTINUE

%*** H ->>
    if ERK * TWO(K + 1) < 0.5 * ERR0 || IPHASE == 1
        HNEW = 1.01 * H;
%        GOTO 1000
        H = HNEW;
%    end

%*** <<- H
    elseif ERK > 0.5 * ERR0
        R    = (0.5 * ERR0 / ERK)^(1.0 / (K + 1));
        HNEW =  min( [0.9 max([0.5 R])] ) * H;
%        GOTO 1000
        H = HNEW;
    else
%*** -> H <-
        HNEW = H;
        H = HNEW;
%    WRITE(25,800) Y(1)-6370.0, HNEW, ERK
% 800  FORMAT(F18.2, F18.6, F18.8)
    end
end
