%************************************************************************
%      SUBROUTINE DENSDE(PATH)
%************************************************************************
function [PATH] = DENSDE(PATH)
    global NSPEC ...
            RREF ETA SHINV ...
            XNDE ...
            DNDDRR

      GPH    = RREF * (PATH(1)-RREF) / PATH(1);
      DGPHDR = (RREF / PATH(1))^2;
      ETEXP2 = ETA(2) * exp(-GPH * SHINV(2));
      ETEXP3 = ETA(3) * exp(-GPH * SHINV(3));
      ETEXP4 = ETA(4) * exp(-GPH * SHINV(4));

      SUM1   = ETEXP2 + ETEXP3 + ETEXP4;
      SUM2   = ETEXP2 * SHINV(2) + ETEXP3 * SHINV(3) + ETEXP4 * SHINV(4);

      XNDE  (1) = sqrt(SUM1);
      XNDE  (2) = ETEXP2 / XNDE(1);
      XNDE  (3) = ETEXP3 / XNDE(1);
      XNDE  (4) = ETEXP4 / XNDE(1);

      DNDDRR(1) =-DGPHDR * SUM2 / SUM1 / 2.0;
      DNDDRR(2) =-DGPHDR * SHINV(2) - DNDDRR(1);
      DNDDRR(3) =-DGPHDR * SHINV(3) - DNDDRR(1);
      DNDDRR(4) =-DGPHDR * SHINV(4) - DNDDRR(1);
end
