%************************************************************************
%     SUBROUTINE DENSLI(PATH)
%     diffusive equilibrium(DE)
%     Lower Ionosphere(LI) model
%************************************************************************

function [PATH] = DENSLI(PATH)
    global RRLI HWLI ...
            XNLI  DNLDRR

%   Li(rr) = 1- exp(-(rr-6460)/140)^2
%   RRLI = 6370+90
%   HWLI = 140
    if (PATH(1)-RRLI) > 0
        ALTNRM = (PATH(1)-RRLI) / HWLI;
        XNLI   = 1.0 - exp(-ALTNRM^2);
        DNLDRR = exp(-ALTNRM^2) * ALTNRM * 2.0 / HWLI / XNLI;
    else
        XNLI = 0.0;
        DNLDRR = 0.0;
    end


%
%
end
