%**********************************************************************
%      SUBROUTINE DIPOLE(PATH)
%**********************************************************************
function [PATH] = DIPOLE(PATH)
    global PAI RAD DEG RE CVLCTY ...
            YR     YT     YP ...
            DYRDRR DYTDRR DYPDRR ...
            DYRDTH DYTDTH DYPDTH ...
            DYRDPH DYTDPH DYPDPH ...
            BB ...
            DBBDRR DBBDTH DBBDPH
%
    GMDM = 8.07 * 10^6;
    RR     = PATH(1);
    TH     = PATH(2);
    PH     = PATH(3);
    COSTH  = cos(RAD * (TH));
    SINTH  = sin(RAD * (TH));
    COSTHS = 1.0 + 3.0 * COSTH^2;
    YR     =-2.0 * COSTH / sqrt(COSTHS);
    YT     =-      SINTH / sqrt(COSTHS);
    YP     = 0.0;
%
    DYRDRR = 0.0;
    DYTDRR = 0.0;
    DYPDRR = 0.0;
    DYRDTH =-2.0 / COSTHS * YT;
    DYTDTH = 2.0 / COSTHS * YR;
    DYPDTH = 0.0;
    DYRDPH = 0.0;
    DYTDPH = 0.0;
    DYPDPH = 0.0;
%
    BB     = GMDM * sqrt(COSTHS) / RR^3;
%
    DBBDRR =-3.0 / RR;
    DBBDTH =-3.0 * SINTH * COSTH / COSTHS;
    DBBDPH = 0.0;
end
