%************************************************************************
%      SUBROUTINE FUNCT(PATH DPATH IMDFY)
%************************************************************************

function [PATH, DPATH] = FUNCT(PATH, DPATH, IMDFY)
    global NSPEC ...
            RAD DEG CVLCTY ...
            FKC DEL EPS GMU ALF RAY ...
            PF0 GF0 ...
            PMU PMUS PMU0 ...
            PSI_angl COPSI  SIPSI COPSIS SIPSIS ...
            PX PY PZ ...
            PA1 PA2 PA3 ...
            PK1 PK2 PK4 PK5 ...
            PA  PB YR YT YP ...
            DYRDRR DYTDRR DYPDRR ...
            DYRDTH DYTDTH DYPDTH ...
            DYRDPH DYTDPH DYPDPH ...
            DBBDRR DBBDTH DBBDPH ...
            XNS DNSDRR DNSDTH DNSDPH ...
%
    PATH = REF(PATH);

    if IMDFY == 1

        PATH(4) = PATH(4) * PMU / PMU0;
        PATH(5) = PATH(5) * PMU / PMU0;
        PATH(6) = PATH(6) * PMU / PMU0;

        DEL = angle( PATH(4) + 1i * PATH(5));
        EPS = atan(PATH(6) / sqrt( PATH(4)^2 + PATH(5)^2 ));
        DEL = DEG * (DEL);
        EPS = DEG * (EPS);
    end

    DMUDRR = 0.0;
    DMUDTH = 0.0;
    DMUDPH = 0.0;
    DK2DF  = 0.0;
    DA3DF  = 0.0;
    DENOM  = (4.0 * PA * PMUS + 2.0 * PB) * PMU;

    for I = 1 : NSPEC
        DADX   = -                       COPSIS;
        DBDX   = -(PK1 / PZ(I) - PK2) * (1.0 + COPSIS);
        DCDX   = - PK5;
        PK2A3Y = 2.0 * (PK2 - PA3 * PY(I));
        DADX   = DADX +           SIPSIS/PZ(I);
        DBDX   = DBDX -    PK2A3Y * SIPSIS/PZ(I);
        DCDX   = DCDX + PK1 * PK2A3Y       /PZ(I);
        DMUDX  = -(DADX * PMUS^2 + DBDX * PMUS + DCDX) / DENOM;

        DK2DY  = -2.0    * PX(I) * PY(I)       / PZ(I)^2;
        DK5DY  =  2.0 * PA3 * PX(I)*(PZ(I) + 2.0) / PZ(I)^2;
        DK5DY  = DK5DY + 2.0 * DK2DY * PK2;
        DADY   =                           DK2DY * SIPSIS;
        DBDY   = -PK1 * DK2DY * (1.0 + COPSIS) - DK5DY * SIPSIS;
        DCDY   =  PK1 * DK5DY;
        DMUDY  = -(DADY * PMUS^2 + DBDY * PMUS + DCDY) / DENOM;

        DXDRR  = PX(I) * DNSDRR(I);
        DXDTH  = PX(I) * DNSDTH(I);
        DXDPH  = PX(I) * DNSDPH(I);
        DYDRR  = PY(I) * DBBDRR;
        DYDTH  = PY(I) * DBBDTH;
        DYDPH  = PY(I) * DBBDPH;
        DMUDRR = DMUDRR + DMUDX * DXDRR + DMUDY * DYDRR;
        DMUDTH = DMUDTH + DMUDX * DXDTH + DMUDY * DYDTH;
        DMUDPH = DMUDPH + DMUDX * DXDPH + DMUDY * DYDPH;

        DK2DFI =  2.0        * PX(I)      / PZ(I)^2;
        DA3DFI = (2.0-PZ(I)) * PX(I) * PY(I) / PZ(I)^2;
        DK2DF  = DK2DF+DK2DFI/FKC;
        DA3DF  = DA3DF+DA3DFI/FKC;
    end



        DADPS  = PA1 + PA2;
        DBDPS  = PK4 - PK5;
        DMUDPS = (DADPS * PMUS + DBDPS) * PMUS;
        DMUDPS = -2.0 * COPSI * DMUDPS / DENOM;

        DPSDRR = DYRDRR * PATH(4) + DYTDRR * PATH(5) + DYPDRR * PATH(6);
        DPSDTH = DYRDTH * PATH(4) + DYTDTH * PATH(5) + DYPDTH * PATH(6);
        DPSDPH = DYRDPH * PATH(4) + DYTDPH * PATH(5) + DYPDPH * PATH(6);
        DPSDRR = -DPSDRR / PMU;
        DPSDTH = -DPSDTH / PMU;
        DPSDPH = -DPSDPH / PMU;

    if XNS(1) ~= 0.0
        DMUDRR = (DMUDRR + DMUDPS * DPSDRR) / PMU;
        DMUDTH = (DMUDTH + DMUDPS * DPSDTH) / PMU;
        DMUDPH = (DMUDPH + DMUDPS * DPSDPH) / PMU;
        DMUDVR = DMUDPS * (PATH(4) * COPSI / PMU - YR);
        DMUDVT = DMUDPS * (PATH(5) * COPSI / PMU - YT);
        DMUDVP = DMUDPS * (PATH(6) * COPSI / PMU - YP);
    else
        DMUDRR = 0.0;
        DMUDTH = 0.0;
        DMUDPH = 0.0;
        DMUDVR = 0.0;
        DMUDVT = 0.0;
        DMUDVP = 0.0;
    end

    DK1DF     = 2.0 * PA1 / FKC;
    DK4DF     =        PK1 * DK2DF + PK2 * DK1DF;
    DK5DF     = 2.0 * (PK2 * DK2DF - PA3 * DA3DF);
    DCDF      =        PK1 * DK5DF    + PK5 * DK1DF;
    DADF      =  DK1DF *       COPSIS + DK2DF * SIPSIS;
    DBDF      = -DK4DF * (1.0 + COPSIS) - DK5DF    * SIPSIS;
    DMUDF     = -((DADF * PMUS + DBDF) * PMUS + DCDF) / DENOM;
    if XNS(1) == 0.0
        DMUDF = 0.0;
    end
    GMU       = PMU + FKC * DMUDF;

    if PATH(1) < 6460.0
       DMUDVR = 0.0;
       DMUDVR = 0.0;
       DMUDVP = 0.0;
       DMUDRR = 0.0;
       DMUDTH = 0.0;
       DMUDPH = 0.0;
    end

    DPATH(1) = PATH(4) - DMUDVR;
    DPATH(2) = PATH(5) - DMUDVT;
    DPATH(3) = PATH(6) - DMUDVP;
    DPATH(1) = DPATH(1) / PMUS;
    DPATH(2) = DPATH(2) / PMUS / PATH(1);
    DPATH(3) = DPATH(3) / PMUS / PATH(1) / sin(RAD * (PATH(2)));
    DPATH(4) = DMUDRR ...
                +PATH(5) * DPATH(2) ...
                +PATH(6) * DPATH(3) * sin(RAD * (PATH(2)));
    DPATH(5) = DMUDTH / PATH(1) ...
                -PATH(5) * DPATH(1) / PATH(1) ...
                +PATH(6) * DPATH(3) * cos(RAD * (PATH(2)));
    DPATH(6) = DMUDPH / PATH(1) / sin(RAD * (PATH(2))) ...
                -PATH(6) * DPATH(1) / PATH(1) ...
                -PATH(6) * DPATH(2) / tan(RAD * (PATH(2)));
    DPATH(2) = DEG * (DPATH(2));
    DPATH(3) = DEG * (DPATH(3));
    DPATH(7) = 1.0 / PMU / CVLCTY;
    DPATH(8) = 1.0 / CVLCTY;

    if XNS(1) == 0.0
        ALF = 0.0;
    end
      ALF = DEG * ( - atan(DMUDPS * SIPSI / PMU ));
      RAY = PSI_angl + ALF;
end
