
%================================================================
%     RAY TRACING PROGRAM FOR VLF WAVE (X-MODE) IN DE-MODEL
%     Dipole model is selected in REF by Call dipole
%     IGRF model is selected in REF by Call IGRF
%     kizami H is shown in Adam_update
%     Result of ray tracing (OUT1) is written in fort.21
%     Instantaneous H is written in fort.25
%========  initial conditions ==================================
%	fq00: wave frequency in kHz
%	rr00: starting radial distance from the earth center in km
%	th00: geomagnetic colatitude in deg latitude
%	ph00: geomagnetic longitude in deg longitude
%	es00: angle between the initial wave normal and geomagnetic
%            meridian plane, in deg (Epsilon) theta
%	dl00: angle between the projected direction of the initial
%            wave normal onto the geomagnetic meridial plane and
%            the radial direction, in deg (Delta) phi

function raytracing_main(input_file)
    % tic
    clear global

    global prm

    %-- read parameters --
    if ~exist('input_filename')
      input_filename = 'prm_list/input_tmp.dat';  % default input filename
    end
    prm = input_param(input_filename);
    if isempty(prm)
      return
    end

    INIT
    OUT0
    ADAMS
    % if you want to switch graph, you divided by the condition.
    GRAPH1

    % toc
end
